from datetime import datetime
import math
import numpy as np


def rps(prob, final_result):
    return 0.5 * sum(math.pow(sum((prob[j] - final_result[j]) for j in range(i + 1)), 2) for i in range(2))


def get_season(date, format=None):
    if format is not None:
        date = datetime.strptime(date, format)
    if date.month < 6:
        return date.year -1
    else:
        return date.year


def get_best_odds(bookmakers):
    best = [0] * 3
    for bookie in bookmakers:
        if bookie.home > best[0]:
            best[0] = bookie.home
        if bookie.draw > best[1]:
            best[1] = bookie.draw
        if bookie.away > best[2]:
            best[2] = bookie.away
    return best


def result_tostring(h_goals, a_goals):
    if h_goals > a_goals:
        return "H"
    elif a_goals > h_goals:
        return "A"
    else:
        return "D"


def vector_to_result(vector):
    if vector == [1,0,0]:
        return "H"
    elif vector == [0,1,0]:
        return "D"
    else:
        return "A"

def result_to_vector(result):
    result = result.upper()
    if result not in ["H", "D", "A"]:
        raise Exception
    if result == 'H':
        return [1, 0, 0]
    elif result == 'D':
        return [0, 1, 0]
    else:
        return [0, 0, 1]

def save_dict_to_file(filepath, dict):
    np.save(filepath, dict)


def load_dict_from_file(filepath):
    return np.load(filepath, allow_pickle=True).item()